///////////////////////////////////////////////////////////////////////////
// Expression generator Ver. 1.1
///////////////////////////////////////////////////////////////////////////

#include <fstream>
#include <iostream>

// Intermediate representation
#include "AstManager.hh"

// Expression generator
#include "ExpressionGenerator.hh"

int main(int argc, char* argv[]) {
  
  if (argc < 3) {
    std::cerr << "Not enough input parameters!\n";
    std::cerr << "Usage: " << argv[0] << " <depth> <digits> <seed>\n";
    std::cerr << "where <depth> is the depth of the expression tree,\n" 
	      << "<digits> is the maximum number of digits that numbers may have, and\n"
	      << "<seed> is the random generation seed (for repeatability).";
    return 0;
  } else {
    AstManager ast;
    ExpressionGenerator generate(ast, atoi(argv[1]), 
				 atoi(argv[2]), atoi(argv[3])); 
    AstNode* program = generate();
    ast.print(std::cout,program);
    return 0;
  }  


} // End of main
